Option Explicit
On Error Resume Next

Dim Action
Dim DBAction 'Double Click Action
Dim SelectedDVD
Dim Status


'-------------------------------------------------------
'- Main ------------------------------------------------
'-------------------------------------------------------
SelectedDVD = "No Selection" 'Make sure it is not -1 or higher so no selection is defined at start of script

Do
	Sleep 1
	Action = GetPropertyValue("DVD.Action")
	If Action <> "Waiting" Then
		SetPropertyValue "DVD.Action", "Waiting"
		Sleep 100
	
		If Action <> "" Then
			Call Handle_Action(Action)
	
			If Err.Number <> 0 Then
				Status = "Error: " & Err.Description
				Err.Clear
			End If
			SetPropertyValue "DVD.Status", Status
		End If
	End If
	
	DBAction = GetPropertyValue("DVD.DB Action")
	If DBAction <> "Waiting" Then
		SetPropertyValue "DVD.DB Action", "Waiting"
		Sleep 100
	
		If DBAction <> "" Then
			Call Handle_DBAction(DBAction)
	
			If Err.Number <> 0 Then
				Status = "Error: " & Err.Description
				Err.Clear
			End If
			SetPropertyValue "DVD.Status", Status
		End If
	End If
Loop


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub Handle_Action(Action)
Dim Data

	Data = Split(Action, "^")

	Select Case Data(0)
		Case "Refresh": Call Refresh_DVDList()
		Case "Select" : Call Get_SelectedDVD(CInt(Data(1)))    '-1 = Current selected DVD
		Case "Play"   : Call Select_DVD(SelectedDVD)
	End Select
End Sub


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub Handle_DBAction(DBAction)
Dim Data

	Data = Split(DBAction, "^")

	Select Case Data(0)
		Case "Select" : Call Select_DVD(CInt(Data(1)))
	End Select
End Sub


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub Refresh_DVDList()
Dim objExcel
Dim objWorkbook
Dim Row
Dim nit
Dim nic
Dim Sort
Dim TotalLines
Dim FileName
Dim DVDList
Dim Temp
Dim DVDName()
Dim DVDNumber()

	SetPropertyValue "DVD.List", ""
	Set objExcel    = CreateObject("Excel.Application")
	Sort            = GetPropertyValue("DVD.Sort")
	FileName        = "C:\Program Files\Meedio\Meedio HouseBot\Config\AutoHome\DVD\DVD.xls"
	DVDList         = ""
	Set objWorkbook = objExcel.Workbooks.Open(FileName)
	Row             = 1
	
	Do Until objExcel.Cells(Row, 1).Value = ""
    		Row = Row + 1
	Loop
	
	ReDim DVDNumber(Row + 1)
	ReDim DVDName(Row + 1)
	TotalLines = Row - 1

	For Row = 1 To TotalLines
		DVDNumber(Row) = objExcel.Cells(Row, 1).Value
		DVDName(Row)   = objExcel.Cells(Row, 2).Value
	Next	

	If Sort <> "Nummer" Then
		For nit = 0 to TotalLines
			For nic = nit + 1 to TotalLines
				If DVDName(nic) < DVDName(nit) Then
					Temp           = DVDName(nic)
					DVDName(nic)   = DVDName(nit)
					DVDName(nit)   = Temp
					Temp           = DVDNumber(nic)
					DVDNumber(nic) = DVDNumber(nit)
					DVDNumber(nit) = Temp
				End If
			Next
		Next
	Else
		For nit = 0 to TotalLines
			For nic = nit + 1 to TotalLines
				If DVDNumber(nic) < DVDNumber(nit) Then
					Temp           = DVDName(nic)
					DVDName(nic)   = DVDName(nit)
					DVDName(nit)   = Temp
					Temp           = DVDNumber(nic)
					DVDNumber(nic) = DVDNumber(nit)
					DVDNumber(nit) = Temp
				End If
			Next
		Next
	End If
	
	For nit = 1 to TotalLines
		DVDList = DVDList & "Select^" & DVDNumber(nit) & vbTAB & DVDNumber(nit) & vbTAB & DVDName(nit) + vbLF
	Next
	
	SetPropertyValue "DVD.List", DVDList
	objExcel.Quit
	Set objWorkbook = Nothing
	Set objExcel    = Nothing
	Status          = " "
End Sub


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub Get_SelectedDVD(Data)

	If IsNumeric(Data) Then
		SelectedDVD = Data
	End If
End Sub


'-------------------------------------------------------
'-------------------------------------------------------
'-------------------------------------------------------
Sub Select_DVD(Data)

	If IsNumeric(Data) Then
		SetPropertyValue "DVD.Status", "DVD Nr: " & Data & " wordt geladen"
		SetPropertyValue "Sony DVD.IR Sony DVD", "Stop"
		Sleep 1500
		SetPropertyValue "Sony DVD.IR Sony DVD", "Stop"
		Sleep 1500
		SetPropertyValue "Sony DVD.IR Sony DVD", "DVD Menu"
		Sleep 1500
		SetPropertyValue "Sony DVD.IR Sony DVD", "Display"
		Sleep 1500
		SetPropertyValue "Sony DVD.IR Sony DVD", "Enter"
		Sleep 1500
		SetPropertyValue "Sony DVD.Numeric Pass-Through", Data
		Sleep 5000
		SetPropertyValue "Sony DVD.IR Sony DVD", "Display"
		Sleep 2000
		SetPropertyValue "Sony DVD.IR Sony DVD", "Display"
		Status = " "
	Else
		Status = "Invalid selection"
	End If
End Sub